/***
** Copyright (C) 2012 Christophe CHAPUIS <chris.chapuis _at_ gmail _dot_ com>
**
** This package is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This package is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this package; if not, write to the Free Software
** Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
**
***/
import QtQuick 1.0

Rectangle {
    // Login : [text entry]
    // Password : [pwd entry]
    color: "transparent"

    property alias loginValue: inputLogin.text
    property alias passwordValue: inputPwd.text

    Column {
        anchors.fill: parent
        anchors.margins: 30
        spacing: 10

        Row {
            anchors.left: parent.left
            anchors.leftMargin: 10
            anchors.right: parent.right
            anchors.rightMargin: 10

            Text {
                id: labelLogin
                color: "white"
                anchors.verticalCenter: parent.verticalCenter
                width: 150
                text: qsTr("Login")
                font.pixelSize: 24
                font.bold: true
            }

            LineInput {
                id: inputLogin
                width: parent.width - 150 - 10 - 10
                anchors.verticalCenter: parent.verticalCenter
            }
        }

        Row {
            anchors.left: parent.left
            anchors.leftMargin: 10
            anchors.right: parent.right
            anchors.rightMargin: 10

            Text {
                id: labelPwd
                color: "white"
                anchors.verticalCenter: parent.verticalCenter
                width: 150
                text: qsTr("Password")
                font.pixelSize: 24
                font.bold: true
            }

            LineInput {
                id: inputPwd
                width: parent.width - 150 - 10 - 10
                anchors.verticalCenter: parent.verticalCenter
                // password specific
                input.echoMode: TextInput.Password
            }
        }
    }
}
