/***
** Copyright (C) 2012 Christophe CHAPUIS <chris.chapuis _at_ gmail _dot_ com>
**
** This package is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This package is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this package; if not, write to the Free Software
** Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
**
***/
import QtQuick 1.0

Rectangle {
    id: sourcesRect
    width: window.width; height: window.height
    color: "#dfdfdf"

    function populateSourcesModel() {
        for(var i=0; typeof window.listSourceModel[i] !== "undefined"; i++ ) {
            sourceList.append({})
        }
    }

    ListModel {
        id: sourceList
    }

    ListView {
        focus: true
        id: sources
        x: 0; y: 0
        width: window.width; height: window.height
        currentIndex: currentSourceIndex
        model: sourceList
        footer: quitButtonDelegate
        delegate: SourceDelegate {}
        highlight: Rectangle { color: "steelblue" }
        highlightMoveSpeed: 9999999
    }
    ScrollBar { scrollArea: sources; height: sources.height; width: 8; anchors.right: sources.right }

    Component.onCompleted: {
        sources.currentIndex = -1
        populateSourcesModel()
    }
}
